import faker from "faker";
export function generateValidNhsNumbers(num) {
    const numbers = [];
    while (numbers.length < num) {
        const number = faker.random.number({ min: 100000000, max: 999999999 }).toString();
        const multipliedTotal = number.split('').reduce((acc, curr, i) => acc + (Number(curr) * (10 - i)), 0);
        const remainder = multipliedTotal % 11;
        let checkDigit = 11 - remainder;
        if (checkDigit === 11) {
            checkDigit = 0;
        }
        if (checkDigit !== 10) {
            numbers.push(`${number}${checkDigit}`);
        }
    }
    return numbers;
}
export function generateInvalidNhsNumbers(num) {
    const numbers = [];
    while (numbers.length < num) {
        let checkDigit;
        const number = faker.random.number({ min: 100000000, max: 999999999 }).toString();
        const multipliedTotal = number.split('').reduce((acc, curr, i) => acc + (Number(curr) * (10 - i)), 0);
        const remainder = multipliedTotal % 11;
        checkDigit = 11 - remainder;
        if (checkDigit === 10) {
            numbers.push(`${number}${checkDigit}`);
        }
    }
    return numbers;
}
export const generateNhsNumber = () => generateValidNhsNumbers(1)[0];
//# sourceMappingURL=generateNhsNumber.js.map